#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "heap.h"

void print_array (double *tab, int size) {
  int i =0;
  for (i =0; i < size - 1; i++) {
    printf ("%f, ", tab[i]);
  }
  printf ("%f\n", tab[i]);
}

int distance_levenshtein (char* str1, char* str2) {
  int len1 = strlen (str1);
  int len2 = strlen (str2);

  int **dist = malloc ( (len1 + 1) * sizeof(int*));
  for (int i = 0; i <= len1; i++) {
    dist[i] = malloc ((len2 + 1) * sizeof (int));
  }

  for (int i = 0; i <= len1; i++) {
    for (int j = 0; j <= len2; j++) {
      dist[i][j] = 0;
    }
  }

  for (int i = 0; i <= len1; i++) {
    dist[i][0] = i;
  }

  for (int i = 0; i <= len2; i++) {
    dist[0][i] = i;
  }

  for (int i = 1; i <= len1; i++) {
    for (int j = 1; j <= len2; j++) {
      int costSubs = 0;
      if (str1[i-1] == str2[j-1]) {
	costSubs = 0;
      }
      else {
	costSubs = 1;
      }

      int v1 = dist[i-1][j]+1;
      int v2 = dist[i][j-1]+1;
      int v3 = dist[i-1][j-1] + costSubs;
      int min = v1 < v2 ? v1 : v2;
      min = min < v3 ? min : v3;
      dist[i][j] = min;
    }
  }

  int res = dist[len1][len2];
  for (int i = 0; i <= len1; i++) {
    free (dist[i]);
  }
  free (dist);
  return res;
}

/* Indice */
typedef struct word_distance_ {
  int distance;
  char *mot;
} word_distance_t;


int main (int argc, char** argv){

  if (argc != 2) {
    printf ("Usage: %s <chaine>\n", argv[0]);
    return EXIT_SUCCESS;
  }
  /* Mot pour lequel on cherche les plus proches dans le
     dictionnaire */
  char *mot = argv[1];

  int size_dictionnaire = 35;
  char* dictionnaire[] = { "belette", "blaireau", "cerf",
    "couleuvre", "chat", "campagnol", "daim", "ecureuil",
    "founine", "geai", "genette", "grenouille", "herisson",
    "hermine", "lapin", "loup", "lievre", "lynx", "loir",
    "martre", "merle", "mesange", "ours", "pinson", "pivert",
    "processionnaire", "pie", "putois", "renard", "salamandre",
    "sanglier", "sitelle", "taupe", "troglodyte", "vipere" };


  /* TODO */
  /* TODO */
  /* TODO */


  return EXIT_SUCCESS;
}
